#define KEYBOARD_BUFFER_SIZE	64

#define	KEYTABLE_SIZE	256

#define SPECIAL_HANDLER_MASK 0xf000

#define SLEEP_TIME_IN_MS 5

#define MAX_INPUT_DEVICES	8
#define INPUT_DEV_NAMELEN	32
#define MAX_ATARI_JOYPORTS	4
#define KEYPAD_JOYSTICK		-1
#define NO_JOYSTICK			255

#define TIMER_READ_JOYSTICK	6969

#define AKEY_OPTION	0xf001
#define AKEY_SELECT 0xf002
#define AKEY_START	0xf003
#define	AKEY_SWITCHRES	0x000d
#define	KEYPAD0		0xf02D
#define KEYPAD1		0xf023
#define	KEYPAD2		0xf028
#define KEYPAD3		0xf022
#define KEYPAD4		0xf025
#define KEYPAD5		0xf00c
#define KEYPAD6		0xf027
#define KEYPAD7		0xf024
#define KEYPAD8		0xf026
#define KEYPAD9		0xf021
#define	INITOSA		0xf040
#define INITOSB		0xf041
#define INITXL		0xf042
#define INITXE		0xf043
#define INIT5200	0xf044
#define SUSPEND_ATARI	0x01
#define SPEED_ATARI		0x02
#define SWITCH_SIO		0x03

/* States for the ulScreenMode variable */
#define	DDRAW_320_200		0x000001
#define DDRAW_320_240		0x000002
#define	DDRAW_640_400		0x000004
#define DDRAW_640_480		0x000008
#define DDRAW_800_600		0x000010
#define DDRAW_NO_MENU_MODE	0x000020
#define DDRAW_FULL_RES_MASK	0x0000FF

#define	MODE_800_600	0x0010
#define MODE_640_480	0x0008
#define MODE_640_400	0x0004
#define MODE_320_240	0x0002
#define MODE_320_200	0x0001

#define WINDOWED_384_240	0x000100
#define WINDOWED_768_480	0x000200
#define DDRAW_WIND_RES_MASK	0x000F00

#define	DDRAW_8BPP			0x001000
#define DDRAW_16BPP			0x002000
#define DDRAW_24BPP			0x004000
#define DDRAW_BPP_MASK		0x00F000

#define DDRAW_FULL			0x010000
#define DDRAW_WIND			0x020000
#define DDRAW_MODE_MASK		0x0F0000

#define DDRAW_NONE			0x100000

#define DISPLAY_MODE_DEFAULT (DDRAW_800_600 | WINDOWED_384_240 | DDRAW_NONE)
/* RGB Modes we can be in when running DDraw windowed */
#define RGB_8BPP			0x0001
#define	RGB_16BPP			0x0002
#define RGB_555				0x0004
#define RGB_565				0x0008
#define	RGB_24BPP			0x0100
#define RGB_32BPP			0x0200
#define RGB_HAVEFOCUS		0x1000

/* Various machine states the Atari can be in */
#define ATARI_UNINITIALIZED		0x0001
#define ATARI_INITIALIZING		0x0002
#define ATARI_HW_READY			0x0004
#define ATARI_WINDOWS_READY		0x0008
#define ATARI_RUNNING			0x0010
#define	ATARI_PAUSED			0x0020
#define ATARI_UI_ACTIVE			0x0040
#define ATARI_JOYSTICK_FOUND	0x0100
#define ATARI_LOAD_FAILED		0x0200
#define ATARI_LOAD_WARNING		0x0400
#define ATARI_CLOSING			0x0800

/* Misc states to be saved out to the Registry */
#define ATARI_FULL_SPEED		0x0001
#define ATARI_ENABLE_PILL		0x0002
#define ATARI_LAST_BOOT_FAILED	0x0004
#define ATARI_ANTICF_ARTIFACT	0x0008
#define ATARI_STICK_RELEASE		0x0010

/* Sound states and registry stuff */
#define SOUND_MMSOUND			0x0001
#define SOUND_DIRECTSOUND		0x0002
#define SOUND_CUSTOM_RATE		0x0004
#define SOUND_FORCE_PRIMARY		0x0008
#define SOUND_NOSOUND			0x0010
#define	SOUND_WRITING_FILE		0x0020

#define DONT_SHOW_SOUND_WARN		0x0001
#define DONT_SHOW_GRAPHICS_WARN		0x0002
#define DONT_SHOW_SOUNDFILE_WARN	0x0004
#define DONT_SHOW_MENU_WARN			0x0008
#define DONT_SHOW_OSA_WARN			0x0010
#define DONT_SHOW_OSB_WARN			0x0020
#define DONT_SHOW_XL_WARN			0x0040
#define DONT_SHOW_5200_WARN			0x0080
#define DONT_SHOW_BASIC_WARN		0x0100
#define DONT_SHOW_JOYSTICK_WARN		0x0200

#define LOADSTRING_STRING_SIZE		1024
